## stellarium 25.2

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.16)
# CMake 3.20+ is required if x-compiling for Windows on ARM
MESSAGE(STATUS "Found CMake ${CMAKE_VERSION}")

CMAKE_POLICY(VERSION 3.16)
# CMake Policies introduced after version CMAKE_MINIMUM_REQUIRED
IF(POLICY CMP0175)
     CMAKE_POLICY(SET CMP0175 OLD)
ENDIF()

SET(ENABLE_EXPORT_COMPILE_COMMANDS 0 CACHE BOOL "Export CMake compile commands for code analysis")
IF(ENABLE_EXPORT_COMPILE_COMMANDS)
    SET(CMAKE_EXPORT_COMPILE_COMMANDS on)
ENDIF(ENABLE_EXPORT_COMPILE_COMMANDS)

# warn about deprecated stuff so that we may try fixing it
SET(CMAKE_WARN_DEPRECATED 1)

SET_PROPERTY(GLOBAL PROPERTY USE_FOLDERS ON)

########### Project name ###########
PROJECT(Stellarium C CXX)

SET(STELLARIUM_RELEASE_BUILD 1 CACHE BOOL "Set 1 to build as an official release (0 for development snapshots).")

########### Detect Qt version
SET(ENABLE_QT6 1 CACHE BOOL "Whether to try building with Qt6. If Qt6 is not found, Qt5 will be used.")
IF(ENABLE_QT6)
    FIND_PACKAGE(Qt6 COMPONENTS Core QUIET)
ENDIF()
if (NOT Qt6_FOUND)
    FIND_PACKAGE(Qt5 REQUIRED COMPONENTS Core)
ENDIF()

# Activate this to error on all things deprecated in 5.15
#add_compile_definitions("QT_DISABLE_DEPRECATED_BEFORE=0x050F00")

# Version of Stellarium has format YY.V.YD, where:
# -- YY (MAJOR) - two last digits of the year of release
# -- V  (MINOR) - version of the release (0 is used before first release)
# -- YD (PATCH) - 0 for releases and the day of the current year for snapshots
# Example: first release in year 2023 has version 23.1.0 and short (public) version 23.1, series 23.0
# Note: Use integer versions instead of strings for easier handling if required
SET(STELLARIUM_MAJOR 25)
# Number of the release (0 is used before first release)
SET(STELLARIUM_MINOR 2)
IF(STELLARIUM_RELEASE_BUILD)
    ADD_DEFINITIONS(-DSTELLARIUM_RELEASE_BUILD)
    SET(CMAKE_BUILD_TYPE Release)
    SET(STELLARIUM_PATCH 0)
ELSE()
    ########### Get revision number for non-release builds ###########
    STRING(TIMESTAMP CDNUMBER "%j")
    MATH(EXPR STELLARIUM_PATCH_DIGIT "${CDNUMBER} + 0" OUTPUT_FORMAT DECIMAL)
    SET(STELLARIUM_PATCH ${STELLARIUM_PATCH_DIGIT})
ENDIF()
# Use integer versions instead of strings for easier handling if required
ADD_DEFINITIONS(
     -DSTELLARIUM_MAJOR=${STELLARIUM_MAJOR}
     -DSTELLARIUM_MINOR=${STELLARIUM_MINOR}
     -DSTELLARIUM_PATCH=${STELLARIUM_PATCH}
)
SET(VERSION "${STELLARIUM_MAJOR}.${STELLARIUM_MINOR}.${STELLARIUM_PATCH}")
SET(STELLARIUM_SERIES "${STELLARIUM_MAJOR}.0")
SET(STELLARIUM_PUBLIC_VERSION "${STELLARIUM_MAJOR}.${STELLARIUM_MINOR}")
SET(PACKAGE stellarium)
STRING(TIMESTAMP CURRENTYEAR "%Y")
SET(COPYRIGHT_YEARS "2000-${CURRENTYEAR}")

SET(STELLARIUM_URL "https://stellarium.org/")
ADD_DEFINITIONS(-DSTELLARIUM_URL="${STELLARIUM_URL}")

# remembering the name and the version of compiler for StelLogger
SET(STELLARIUM_COMPILER "${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}")
ADD_DEFINITIONS(-DSTELLARIUM_COMPILER="${STELLARIUM_COMPILER}")

# The line below is copied from src/gui/HelpDialog.cpp file
SET(STELLARIUM_COPYRIGHT "Copyright (C) ${COPYRIGHT_YEARS} ${PROJECT_NAME} Developers")
# The line below is copied from src/main.cpp file
#SET(STELLARIUM_COPYRIGHT "Copyright (C) ${COPYRIGHT_YEARS} Fabien Chereau et al.")
ADD_DEFINITIONS(-DSTELLARIUM_COPYRIGHT="${STELLARIUM_COPYRIGHT}")

# Define URL for usage within program (feedback URL for plug-ins)
SET(STELLARIUM_DEV_URL "https://github.com/Stellarium/stellarium")
ADD_DEFINITIONS(-DSTELLARIUM_DEV_URL="${STELLARIUM_DEV_URL}")

SET(PACKAGE_VERSION "${VERSION}")
ADD_DEFINITIONS(-DPACKAGE_VERSION="${PACKAGE_VERSION}")
ADD_DEFINITIONS(-DCOPYRIGHT_YEARS="${COPYRIGHT_YEARS}")
ADD_DEFINITIONS(-DSTELLARIUM_SOURCE_DIR="${PROJECT_SOURCE_DIR}")
ADD_DEFINITIONS(-DSTELLARIUM_PUBLIC_VERSION="${STELLARIUM_PUBLIC_VERSION}")
ADD_DEFINITIONS(-DSTELLARIUM_SERIES="${STELLARIUM_SERIES}")

# Qt 5.15+ is preferred as it provides version-less CMake functions (QT_WRAP_UI etc.)
IF(Qt6_FOUND)
     SET(MINIMAL_QT_VERSION "6.2.0")
     IF(NOT DEFINED QT_VERSION_MAJOR)
         SET(QT_VERSION_MAJOR 6)
     ENDIF()
ELSE()
     SET(MINIMAL_QT_VERSION "5.12.0")
     IF(NOT DEFINED QT_VERSION_MAJOR)
         SET(QT_VERSION_MAJOR 5)
     ENDIF()
ENDIF()
# TODO: Check real minimal supported version of GPSD API
SET(MINIMAL_GPS_API_VERSION "6.0")

### Define minimal version for Windows
# Use installer for checking minimum requirements
# Stellarium/MSVC require Windows 7 (6.1) for work
# Details: http://www.jrsoftware.org/ishelp/index.php?topic=winvernotes
IF(Qt6_FOUND)
     SET(ISS_MIN_WIN_VERSION "10.0")
ELSE()
     SET(ISS_MIN_WIN_VERSION "6.1")
ENDIF()
# Define required version for MSVC
# Details: https://docs.microsoft.com/ru-ru/windows/win32/winprog/using-the-windows-headers
IF(Qt6_FOUND)
     SET(MIN_WIN_VERSION "0x0A00")
ELSE()
     SET(MIN_WIN_VERSION "0x0601")
ENDIF()

# Use customized cmake macros
SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/modules)
INCLUDE(CPM)

# Show platform info
MESSAGE(STATUS "Platform: ${CMAKE_SYSTEM} (${CMAKE_SYSTEM_PROCESSOR})")

########### Main global variables ###########
SET(ENABLE_TESTING 0 CACHE BOOL "Define whether the unit tests should be activated.")
SET(ENABLE_LTO 0 CACHE BOOL "Define whether the Link Time Optimization should be activated.")
SET(ENABLE_PCH 1 CACHE BOOL "Define whether to use precompiled headers.")

IF(NOT CMAKE_BUILD_TYPE)
     SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug GProf Valgrind ASan UBSan Release RelWithDebInfo MinSizeRel." FORCE)
ENDIF()

IF(${CMAKE_BUILD_TYPE} MATCHES "Debug")
     IF(CMAKE_COMPILER_IS_GNUCXX)
          INCLUDE(CodeCoverage)
          IF(LCOV_PATH AND ENABLE_TESTING)
               APPEND_COVERAGE_COMPILER_FLAGS()
               MESSAGE(STATUS "Found lcov ${LCOV_PATH} (enable coverage support)")
               SETUP_TARGET_FOR_COVERAGE_LCOV(
                    NAME coverage
                    EXECUTABLE ctest -j ${PROCESSOR_COUNT}
                    DEPENDENCIES buildTests
               )
          ENDIF()
     ENDIF()
ENDIF()

IF(STELLARIUM_RELEASE_BUILD)
     SET(ISS_PACKAGE_VERSION "${STELLARIUM_PUBLIC_VERSION}")
     SET(STELLARIUM_BUIDING_VERSION "${STELLARIUM_PUBLIC_VERSION}")
ELSE()
     SET(STELLARIUM_SERIES "head")
     FIND_PACKAGE(Git QUIET)
     IF(Git_FOUND)
          MESSAGE(STATUS "Found Git ${GIT_VERSION_STRING}")
          # get the name of current branch
          EXECUTE_PROCESS(COMMAND ${GIT_EXECUTABLE} rev-parse --abbrev-ref HEAD WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} TIMEOUT 30 OUTPUT_VARIABLE GIT_BRANCH OUTPUT_STRIP_TRAILING_WHITESPACE ERROR_VARIABLE GIT_ERROR)
          # get the hash of latest commit
          EXECUTE_PROCESS(COMMAND ${GIT_EXECUTABLE} log -1 --pretty=format:%h WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} TIMEOUT 30 OUTPUT_VARIABLE GIT_REVISION OUTPUT_STRIP_TRAILING_WHITESPACE ERROR_VARIABLE GIT_ERROR)
          # get the name of latest annotated tag
          EXECUTE_PROCESS(COMMAND ${GIT_EXECUTABLE} describe --tags --abbrev=0 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} TIMEOUT 30 OUTPUT_VARIABLE GIT_TAGS OUTPUT_STRIP_TRAILING_WHITESPACE ERROR_VARIABLE GIT_ERROR)
	  IF(GIT_REVISION)
               # Let's use short hash in all cases
               STRING(SUBSTRING ${GIT_REVISION} 0 7 REVISION)
	       ADD_DEFINITIONS(-DGIT_REVISION="${REVISION}")
               ADD_DEFINITIONS(-DGIT_BRANCH="${GIT_BRANCH}")
	  ENDIF()
     ELSE()
          STRING(TIMESTAMP TODAY "%j%H%M")
          SET(REVISION "${TODAY}")
	  ADD_DEFINITIONS(-DGIT_REVISION="${TODAY}")
          ADD_DEFINITIONS(-DGIT_BRANCH="tarball")
     ENDIF()
     SET(ISS_PACKAGE_VERSION "${STELLARIUM_PUBLIC_VERSION}-${REVISION}")
     SET(STELLARIUM_BUIDING_VERSION "${STELLARIUM_PUBLIC_VERSION}+")
ENDIF()
MESSAGE(STATUS "Building ${PROJECT_NAME} ${STELLARIUM_BUIDING_VERSION} (v${PACKAGE_VERSION}; Mode: ${CMAKE_BUILD_TYPE})")
ADD_DEFINITIONS(-DSTELLARIUM_BUIDING_VERSION="${STELLARIUM_BUIDING_VERSION}")

# Write version and series of Stellarium to Stellarium User Guide
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/cmake/version.tex.cmake ${PROJECT_SOURCE_DIR}/guide/version.tex @ONLY NEWLINE_STYLE LF)

SET(OPENGL_DEBUG_LOGGING 0 CACHE BOOL "Enable to log OpenGL information using the GL_KHR_debug extension/QOpenGLLogger")
IF(OPENGL_DEBUG_LOGGING)
     ADD_DEFINITIONS(-DOPENGL_DEBUG_LOGGING)
     # This enables logging of QOpenGLFunctions through forced glGetError after each call
     ADD_DEFINITIONS(-DQ_ENABLE_OPENGL_FUNCTIONS_DEBUG)
ENDIF()

# Use ccache if possible
IF(NOT WIN32)
     FIND_PROGRAM(CCACHE_PROGRAM ccache)
     IF(CCACHE_PROGRAM)
          MESSAGE(STATUS "Found ccache ${CCACHE_PROGRAM}")
          SET_PROPERTY(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
     ENDIF()
ENDIF()

# Add gprof build options if necessary.  Note gmon.out will be created in working directory when Stellarium is executed
IF(${CMAKE_BUILD_TYPE} MATCHES "GProf")
     SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fprofile-arcs")
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs")
     SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
ENDIF()

# Add valgrind build options if necessary
IF(${CMAKE_BUILD_TYPE} MATCHES "Valgrind")
     SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O0 -g")
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0 -g")
ENDIF()

# Add ASan (AddressSanitizer) build options if necessary
# Details: https://github.com/google/sanitizers/wiki/AddressSanitizer
#          https://docs.microsoft.com/ru-ru/cpp/build/reference/fsanitize?view=msvc-150
IF(${CMAKE_BUILD_TYPE} MATCHES "ASan")
     IF(MSVC)
          SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /fsanitize=address")
          SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fsanitize=address")
     ELSE()
          SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -O1 -fno-omit-frame-pointer -g")
          SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -O1 -fno-omit-frame-pointer -g")
     ENDIF()
ENDIF()

# Add UBSan (UndefinedBehaviorSanitizer) build options if necessary
# Details: https://clang.llvm.org/docs/UndefinedBehaviorSanitizer.html
IF(${CMAKE_BUILD_TYPE} MATCHES "UBSan")
     SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=undefined -g")
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined -g")
ENDIF()

# Add Fuzzer (Fuzzer Sanitizer) build options if necessary
# Details: https://llvm.org/docs/LibFuzzer.html
#          https://docs.microsoft.com/ru-ru/cpp/build/reference/fsanitize?view=msvc-150
IF(${CMAKE_BUILD_TYPE} MATCHES "Fuzzer")
     IF(MSVC)
          SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /fsanitize=fuzzer")
          SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fsanitize=fuzzer")
     ELSE()
          SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=fuzzer -O1 -g")
          SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=fuzzer -O1 -g")
     ENDIF()
ENDIF()

IF(APPLE)
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
     # share data location:
     SET(SDATALOC "Resources")
ELSE()
     IF(HAIKU)
	  SET(SDATAPREFIX "data")
     ELSE()
	  SET(SDATAPREFIX "share")
     ENDIF()
     # share data location:
     SET(SDATALOC "${SDATAPREFIX}/${PACKAGE}")
ENDIF()

IF(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_GNUCC)
     IF(WIN32)
        # The stars structs rely on gnu gcc packing of bit-fields.
        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mno-ms-bitfields")
     ENDIF()
     SET(GCC_VERSION "${CMAKE_CXX_COMPILER_VERSION}")
ELSE()
     SET(GCC_VERSION "0.0")
ENDIF()

# _USE_MATH_DEFINES enables use of math constants like M_PI,
# which are by default disabled in standard C++ mode (like std=c++11 instead of std=gnu11)
ADD_DEFINITIONS(-D_USE_MATH_DEFINES)

# flags shared for gcc-like compilers (also MinGW/Clang)
# Qt 5.7 requires C++11 support
SET(STEL_GCC_C_FLAGS "-Wall -Wextra -Wno-unused-parameter -Wno-unknown-pragmas")
SET(STEL_GCC_CXX_FLAGS "-Wall -Wextra -Wno-unused-parameter -Wno-unknown-pragmas")

=== guide/Makefile ===
# Makefile for the Stellarium User Guide (SUG)
# Required tools:
# WINDOWS 
# ========
# It is possible to run make from the Windows command shell or from Linux-like environments: CygWin, Ubuntu shell or at least the Git shell. 
# If cygwin or Ubuntu are your favorite environments and you have already installed TeXlive there, 
# you won't need MiKTeX, but can use the existing installations. Else install these tools:
# * make and touch from GnuWin32
# * MiKTeX from http://miktex.org. Configure it to auto-download packages as required.
# * pdftk.exe from https://www.pdflabs.com/tools/pdftk-server/ or the pdftk.exe in the program folder of the "private" GUI version.
# * GhostScript from https://www.ghostscript.com. Make sure to have the distribution's bin directory in PATH.
# GIT shell: Install these tools and just make sure they are found in PATH!
# CygWin: To build SUG with native tools, install the relevant packages from the Cygwin repository; alternatively, the Windows tools will be called
# Ubuntu: apt-get install make texlive-full gs pdftk. On Windows' Ubuntu shell, the native Windows tools can be used if available in PATH.
#
# LINUX
# =======
# Debian, Ubuntu: apt-get install make texlive-full gs pdftk. 
# Others: make sure to install the abovementioned packages for your distribution.
#
# MAC OS X
# ==========
# * TODO: please add instructions here.



# We try to detect Windows or other system to configure the tool names properly. 
# Problem: Ubuntu shell on Windows does not know environment variable OS. 
# https://stackoverflow.com/questions/38086185/how-to-check-if-a-program-is-run-in-bash-on-ubuntu-on-windows-and-not-just-plain
#
# On Windows with git shell, Ubuntu bash or cygwin, use rm and mv, not del and move. 
# Note that make resets SHELL to sh.exe. 
# Cygwin/Ubuntu/MinGW/Git shell's version includes full path name with forward-slash, signalling bash use.
# So far we can also assume that we are on pure (poor) Windows commandline if SHELL=sh.exe

PDFLATEX=pdflatex
HTLATEX=htlatex
BIBER=biber
MAKEINDEX=makeindex
MAKE4HT=make4ht

ifeq ($(OS),Windows_NT) # variable OS not set under Win10/Ubuntu!
	ifeq ($(findstring /sh, $(SHELL)),/sh)
		RM=rm -fr
		MV=mv
		ifeq ($(findstring gs,$(shell which gs 2>/dev/null)),gs)
			GS=gs
		else
			ifeq ($(findstring gswin64c,$(shell which gswin64c 2>/dev/null)),gswin64c)
				GS=gswin64c.exe
			else
				GS=gswin32c.exe
			endif
			MAKE4HT=make4ht.exe
		endif
		PDFTK=pdftk
	else # cmd shell. TODO: hide error message of "where".
		RM=del /Q
		MV=rename
		ifeq ($(findstring gswin64c,$(shell where gswin64c)),gswin64c)
				GS=gswin64c.exe
			else
				GS=gswin32c.exe
			endif
		PDFTK=pdftk.exe
		MAKE4HT=make4ht.exe
	endif
else 
	# OS not Windows on most Non-Windows environments, but may still be Ubuntu bash on Windows! 
	# In essence, if tool not found, fall back to that tools' names from the Windows environment.
	# It is assumed that at least the Windows tools are configured to lie in PATH.
	ifneq ($(findstring pdflatex, $(shell which pdflatex)),pdflatex)
		PDFLATEX=pdflatex.exe
	endif
	ifneq ($(findstring htlatex, $(shell which htlatex)),htlatex)
		HTLATEX=htlatex.exe
	endif
	ifneq ($(findstring biber, $(shell which biber)),biber)
		BIBER=biber.exe
	endif
	ifneq ($(findstring makeindex, $(shell which makeindex)),makeindex)
		MAKEINDEX=makeindex.exe
	endif
	ifneq ($(findstring pdftk, $(shell which pdftk)),pdftk)
		PDFTK=pdftk.exe
	else	
		PDFTK=pdftk
	endif
	ifneq ($(findstring gs,$(shell which gs)),gs)
		GS=gswin64c.exe
	else
		GS=gs
	endif
	RM=rm -fr 
	MV=mv
	SHELL=/bin/bash
endif

# htlatex needs bounding box files.
PICSpdf=$(wildcard pictures/*.pdf)
PICSpng=$(wildcard pictures/*.png) $(subst .pdf,.png, ${PICSpdf})
PICSjpg=$(wildcard pictures/*.jpg)
PICSbbx=$(subst .png,.xbb, ${PICSpng}) $(subst .jpg,.xbb, ${PICSjpg})


.DEFAULT:
.PHONY: help diag clean distclean guide pdf manual SUG html

.SUFFIXES:
.SUFFIXES: .tex .aux .log .lot .lof .toc .bbl .ind .dvi .pdf .eps .jpg .png .html .ps

# This is to keep intermediate files until explicitly removed with make clean.
.SECONDARY:


help:
	@echo               Stellarium Manual Options
	@echo               ==========================
	@echo PDFLaTeX creates the prettiest PDF, but it is quite large.
	@echo targets: 
	@echo clean: remove intermediate files.
	@echo distclean: also remove the PDF targets SUG.pdf, guide.pdf
	@echo pdf = guide = manual = guide.pdf :  Stellarium User Guide \(hi-res\)
	@echo SUG = SUG.pdf : as final target applies compression via GhostScript \(slow!\)
	@echo html: create online version. \(EXPERIMENTAL, WIP\)
	@echo diag: print some diagnostics about tool names.

clean:
	${RM} *~ core *.aux *.log *.lof *.toc *.out *.blg *.bcf *.bbl *.idx *.ilg *.ind *.ptc
	${RM} *.run.xml *.4ct *.4tc *.tmp *.dvi guide_meta.txt *.html *.lg *.idv *.css *.svg *.xref guide*.png 

distclean: clean
	${RM} guide.pdf SUG.pdf ${PICSbbx} html

manual: guide.pdf

guide: guide.pdf

pdf: guide.pdf 

dvi: guide.dvi

html: guide.html

# Installation notes for some tools:
# Use any recent LaTeX distribution like TeXlive (Linux) or MiKTeX 2.9 or later. 

# The size reduction will need GhostScript and some add-on tools.
# 2 options were explored on Windows 10's Ubuntu 14.04 LTS: 
# * install https://github.com/pts/pdfsizeopt 
#   sudo apt-get install default-jre 
#   download Multivalent.jar from https://sourceforge.net/projects/multivalent/?source=typ_redirect and put it into PATH
#   The official project seems defunct. Found old version at  http://www.accountingenhancements.com/multivalent.sourceforge.net/files/Multivalent20060102.jar 
#   run target SUG.pdf
# * optpdf. This removes the opening view settings from the PDF which have to be restored with pdfmark hacks.
#   We also need pdftk for this.
# --> make SUG.pdf

# ================ GENERAL RULES ==================================

# TODO: A rule that securely detects when guide.pdf is complete and no more action is required. Probably we need to make out own logfile grep for "Rerun Latex" and a stop file target.
# Issue: bbl depends on bcf which is created on every run. Likewise, ind depends in idx. We should detect when pdflatex does not emit a warning about changed page numbers.
# Currently, we assume page numbers have settled by the 3rd run, and artificially change the file ages with touch to convince make to stop.

#%.tex : ;
#Makefile: ;
# we must call makeindex again just before final run to update page numbers. Not too intuitive, but seems necessary...
guide.pdf : guide.ind guide.bbl 
	${PDFLATEX} '\PassOptionsToPackage{draft}{graphicx}\input guide.tex'
	${MAKEINDEX} guide.idx -s StyleInd.ist
	${PDFLATEX} '\PassOptionsToPackage{draft}{graphicx}\input guide.tex'
	${PDFLATEX} guide.tex
	@touch -c guide.ind
	@touch -c guide.bbl
	@touch -c $@

guide.dvi : guide.tex
	+make ${PICSpng}
	+make ${PICSbbx}
	latex $<

#guide.ind: guide.idx guide.toc
guide.ind: guide.idx guide.aux
	${MAKEINDEX} guide.idx -s StyleInd.ist

guide.bbl: guide.bcf guide.bib
	${BIBER} guide

guide.idx: guide.log

guide.toc: guide.log	

guide.bcf: guide.log

guide.aux: guide.log

guide.log: $(wildcard *.tex) 
	${PDFLATEX} guide.tex

SUG SUG.pdf: guide_opt.pdf
	${MV} $< SUG.pdf

%_meta.txt : %.pdf
	${PDFTK} $< dump_data_utf8 > $@


# Reduced file size by 65%. But we need to restore some meta info.
%_opt.pdf : %.pdf %_meta.txt %_pdfmark.ps
	${GS} -sDEVICE=pdfwrite -dCompatibilityLevel=1.6 -dNOPAUSE -dQUIET -dBATCH  -sOutputFile=$*_gswrite.pdf  $*.pdf $*_pdfmark.ps 
	${PDFTK} $*_gswrite.pdf update_info_utf8 $*_meta.txt output $@
	${RM} $*_gswrite.pdf $*_meta.txt 


pdf2png: $(subst .pdf,.png, ${PICSpdf})

pictures/%.png : pictures/%.pdf
	convert $< $@

%.xbb: %.png
	ebb -x $<

%.xbb: %.jpg
	ebb -x $<

## pdfsizeopt unfortunately hardly makes the SUG smaller :-(	
## But it is recommended to run Multivalent after that!
## NOPE! It destroys images.
#SUG.pdf : guide.pdf	
#	pdfsizeopt $< $@
#	java -classpath Multivalent20060102.jar tool.pdf.Compress -jpeg $@
#	mv SUG-o.pdf SUG.pdf

htdia:
	@echo Want to create ${PICSbbx}


# HTML: Work in progress. I run into many issues that have been discussed in various TeX fora.
# TODO: Whoever knows about htlatex/tex4ht is welcome to help in fixing formatting macros or properly
# configuring the build of a friendly frame set.
# it seems tex4ht needs more than just running htlatex, but we need some configuration file.
#guide.html: guide.bbl guide.ind
#
# See https://github.com/michal-h21/helpers4ht/wiki/tex4ht-tutorial
# htlatex filename "options for tex4ht.sty" "options for tex4ht" "options for t4ht" "LaTeX options"

html-draft: $(wildcard *.tex) ${PICSbbx}
	@echo Shell is $(SHELL)
	make4ht --output-dir html --utf8 guide -m draft guide "htFixes" 
#	make4ht --output-dir html --utf8 guide -m draft guide "htFixes"


# GZ we don't use the htlatex command script because it does not call biber or makeindex. 
# guide.mk4 is a config file for Stellarium HTML Guide to be processed by make4ht. See https://github.com/michal-h21/make4ht for details.

guide.html: $(wildcard *.tex) guide.mk4 htFixes.cfg ${PICSbbx}
	@echo Shell is $(SHELL)
	${MAKE4HT} --output-dir html --utf8 guide "htFixes" 
#	make4ht --output-dir html --utf8 guide "htFixes" " -cunihtf -utf8"
#	${HTLATEX} guide "htFixes" " -cunihtf -utf8"
# Currently, everything after running biber fails. :-(
#	${BIBER} guide
#	tex '\def\filename{{guide}{idx}{4dx}{ind}} \input  idxmake.4ht'
#	${MAKEINDEX} -o guide.ind guide.4dx
#	${HTLATEX} guide "htFixes,html,1,next,index=3,fn-in,frames,mouseover,info"
#	${HTLATEX} guide "htFixes,html,1,next,index=3,fn-in,frames,mouseover,info"



# This throws an error by lua when processing the tex line. The currently used mk4 lacks the index related stuff.
# Also, it seems ${filename} in the biber argument does not work properly. Should be target without extension.
guide.mk4: 		
	@echo if mode == "draft" then   > $@
	@echo Make:htlatex()           >> $@
	@echo else                     >> $@
	@echo   Make:add("biber", "biber ${input}")                                                        >> $@
	@echo   Make:add("texindex", "tex '\def\filename{{guide}{idx}{4dx}{ind}} \input  idxmake.4ht'") >> $@
	@echo   Make:add("makeindex", "$makeindex ${filename}.idx -s StyleInd.ist")                     >> $@
	@echo   local filter = require "make4ht-filter"                                                 >> $@
	@echo   local process = filter{"cleanspan", "fixligatures", "hruletohr", "fix-links"}           >> $@
	@echo   Make:htlatex()     >> $@
	@echo   Make:biber()       >> $@
	@echo   Make:texindex()    >> $@
	@echo   Make:makeindex()   >> $@
	@echo   Make:htlatex()     >> $@
	@echo   Make:htlatex()     >> $@
	@echo   Make:match("html$",process)                                 >> $@
	@echo  Make:match("html$", "tidy -m -xml -utf8 -q -i ${filename}")  >> $@
	@echo end                  >> $@



# Totally non-tex4ht: Try pandoc? (start to collect arguments here, try "make pandoc")
# Ubuntu on Windows only has pandoc 1.12. Maybe V2 would be more complete? In any case, tabu or some other package seems to be a problem.
pandoc:
		pandoc -f latex -t plain guide.tex


# Hint on restoring initial view settings
# from https://stackoverflow.com/questions/25544002/command-line-tool-to-mark-pdf-to-open-in-single-page-view	
#guide_pdfmark.ps: Makefile
#		echo "[ /PageMode /UseOutlines  % Display bookmarks upon opening the doc\n\
#             %/PageMode /UseThumbs    % Display thumbnails upon opening the doc\n\
#              %/PageMode /FullScreen   % Open the document in fullscreen mode\n\
#              %/PageMode /None         % Display neither bookmarks nor thumbnails upon opening\n\
#              /Page 1                 % Open document with page 1\n\
#              %/View [ /XYZ null null null ]\n\
#                          % Go to specified page and retain same ... \n\
#                          % ... horizontal/vertical offset+zoom as current page\n\

=== skycultures/CMakeLists.txt ===
ADD_SUBDIRECTORY( anutan )
ADD_SUBDIRECTORY( arabic_al-sufi )
ADD_SUBDIRECTORY( arabic_arabian_peninsula )
ADD_SUBDIRECTORY( arabic_indigenous )
ADD_SUBDIRECTORY( arabic_lunar_mansions )
# Exclude from standard package
# ADD_SUBDIRECTORY( armintxe )
ADD_SUBDIRECTORY( aztec )
ADD_SUBDIRECTORY( babylonian_mulapin )
ADD_SUBDIRECTORY( babylonian_seleucid )
ADD_SUBDIRECTORY( belarusian )
ADD_SUBDIRECTORY( boorong )
ADD_SUBDIRECTORY( chinese )
ADD_SUBDIRECTORY( chinese_chenzhuo )
ADD_SUBDIRECTORY( chinese_song_dynasty )
# Exclude from standard package
# ADD_SUBDIRECTORY( egyptian )
ADD_SUBDIRECTORY( egyptian_dendera )
ADD_SUBDIRECTORY( greek_almagest )
ADD_SUBDIRECTORY( greek_dante )
ADD_SUBDIRECTORY( greek_farnese )
ADD_SUBDIRECTORY( greek_leidenAratea )
ADD_SUBDIRECTORY( hawaiian_starlines )
ADD_SUBDIRECTORY( inuit )
ADD_SUBDIRECTORY( indian )
ADD_SUBDIRECTORY( japanese_moon_stations )
ADD_SUBDIRECTORY( kamilaroi )
ADD_SUBDIRECTORY( khoi-san )
ADD_SUBDIRECTORY( korean )
ADD_SUBDIRECTORY( lokono )
ADD_SUBDIRECTORY( macedonian )
ADD_SUBDIRECTORY( maori )
# Exclude from standard package
# ADD_SUBDIRECTORY( maya )
ADD_SUBDIRECTORY( modern )
ADD_SUBDIRECTORY( modern_chinese )
ADD_SUBDIRECTORY( modern_rey )
ADD_SUBDIRECTORY( modern_iau )
ADD_SUBDIRECTORY( modern_hlad )
ADD_SUBDIRECTORY( modern_st )
# Exclude from standard package
# ADD_SUBDIRECTORY( modern_sternenkarten )
ADD_SUBDIRECTORY( mongolian )
ADD_SUBDIRECTORY( navajo )
ADD_SUBDIRECTORY( norse )
ADD_SUBDIRECTORY( northern_andes )
ADD_SUBDIRECTORY( romanian )
ADD_SUBDIRECTORY( ruanui_sky_tahiti_and_society_islands )
ADD_SUBDIRECTORY( russian_siberian )
ADD_SUBDIRECTORY( sami )
ADD_SUBDIRECTORY( samoan )
ADD_SUBDIRECTORY( sardinian )
ADD_SUBDIRECTORY( seri )
ADD_SUBDIRECTORY( tibetan )
ADD_SUBDIRECTORY( tongan )
ADD_SUBDIRECTORY( tukano )
ADD_SUBDIRECTORY( tikuna )
ADD_SUBDIRECTORY( tupi )
ADD_SUBDIRECTORY( vanuatu_netwar )
ADD_SUBDIRECTORY( xhosa )
ADD_SUBDIRECTORY( zulu )

INSTALL(FILES "common_star_names.fab" DESTINATION ${SDATALOC}/skycultures)

=== src/CMakeLists.txt ===
#add our external dependencies first
add_subdirectory(external)

IF(ENABLE_SPOUT)
    SET(spout_SRCS
     external/SpoutLibrary.h
     core/SpoutSender.hpp
     core/SpoutSender.cpp
	 )
ENDIF()

SET(stellarium_lib_SRCS
     core/BlueNoiseTriangleRemapped.hpp
     core/StelSRGB.hpp
     core/StelSRGB.cpp
     core/Dithering.hpp
     core/Dithering.cpp
     core/SaturationShader.hpp
     core/StelAudioMgr.hpp
     core/StelAudioMgr.cpp
     core/StelVideoMgr.hpp
     core/StelVideoMgr.cpp
     core/StelGeodesicGrid.cpp
     core/StelGeodesicGrid.hpp
     core/StelMovementMgr.cpp
     core/StelMovementMgr.hpp
     core/StelObserver.cpp
     core/StelObserver.hpp
     core/StelLocation.hpp
     core/StelLocation.cpp
     core/StelLocationMgr.hpp
     core/StelLocationMgr_p.hpp
     core/StelLocationMgr.cpp
     core/StelProjector.cpp
     core/StelProjector.hpp
     core/StelProjectorClasses.cpp
     core/StelProjectorClasses.hpp
     core/StelProjectorType.hpp
     core/StelSkyDrawer.cpp
     core/StelSkyDrawer.hpp
     core/StelPainter.hpp
     core/StelPainter.cpp
     core/MultiLevelJsonBase.hpp
     core/MultiLevelJsonBase.cpp
     core/StelSkyImageTile.hpp
     core/StelSkyImageTile.cpp
     core/SolarEclipseComputer.hpp
     core/SolarEclipseComputer.cpp
     core/SphericMirrorCalculator.cpp
     core/SphericMirrorCalculator.hpp
     core/StelApp.cpp
     core/StelApp.hpp
     core/StelCore.cpp
     core/StelCore.hpp
     core/StelFileMgr.cpp
     core/StelFileMgr.hpp
     core/StelLocaleMgr.cpp
     core/StelLocaleMgr.hpp
     core/StelModule.cpp
     core/StelModule.hpp
     core/StelModuleMgr.cpp
     core/StelModuleMgr.hpp
     core/StelObject.cpp
     core/StelObject.hpp
     core/StelObjectMgr.cpp
     core/StelObjectMgr.hpp
     core/StelObjectModule.cpp
     core/StelObjectModule.hpp
     core/StelObjectType.hpp
     core/StelOpenGL.cpp
     core/StelOpenGL.hpp
     core/StelPluginInterface.hpp
     core/StelRegionObject.hpp
     core/StelSkyCultureMgr.cpp
     core/StelSkyCultureMgr.hpp
     core/StelSkyCultureSkyPartition.cpp
     core/StelSkyCultureSkyPartition.hpp
     core/StelTextureMgr.cpp
     core/StelTextureMgr.hpp
     core/StelTexture.cpp
     core/StelTexture.hpp
     core/StelTextureTypes.hpp
     core/StelToneReproducer.cpp
     core/StelToneReproducer.hpp
     core/StelSkyLayerMgr.cpp
     core/StelSkyLayerMgr.hpp
     core/StelSkyLayer.hpp
     core/StelSkyLayer.cpp
     core/StelFader.hpp
     core/StelSphereGeometry.cpp
     core/StelSphereGeometry.hpp
     core/OctahedronPolygon.cpp
     core/OctahedronPolygon.hpp
     core/StelIniParser.cpp
     core/StelIniParser.hpp
     core/StelUtils.cpp
     core/StelUtils.hpp
     core/StelTranslator.cpp
     core/StelTranslator.hpp
     core/VecMath.hpp
     core/VecMath.cpp
     core/StelJsonParser.hpp
     core/StelJsonParser.cpp
     core/SimbadSearcher.hpp
     core/SimbadSearcher.cpp
     core/StelSphericalIndex.hpp
     core/StelSphericalIndex.cpp
     core/StelVertexArray.hpp
     core/StelVertexArray.cpp
     core/StelGuiBase.hpp
     core/StelGuiBase.cpp
     core/StelViewportEffect.hpp
     core/StelViewportEffect.cpp
     core/TrailGroup.hpp
     core/TrailGroup.cpp
     core/RefractionExtinction.hpp
     core/RefractionExtinction.cpp
     core/StelToast.hpp
     core/StelToast.cpp
     core/StelToastGrid.hpp
     core/StelToastGrid.cpp
     core/StelActionMgr.hpp
     core/StelActionMgr.cpp
     core/StelProgressController.hpp
     core/StelPropertyMgr.hpp
     core/StelPropertyMgr.cpp
     core/StelOBJ.hpp
     core/StelOBJ.cpp
     core/GeomMath.hpp
     core/GeomMath.cpp
     core/StelOpenGLArray.hpp
     core/StelOpenGLArray.cpp
     core/StelHips.hpp
     core/StelHips.cpp
     core/StelHealpix.hpp
     core/StelHealpix.cpp
     core/TextureAverageComputer.hpp
     core/TextureAverageComputer.cpp

     ${spout_SRCS}

     core/planetsephems/calc_interpolated_elements.c
     core/planetsephems/calc_interpolated_elements.h
     core/planetsephems/elliptic_to_rectangular.c
     core/planetsephems/elliptic_to_rectangular.h
     core/planetsephems/elp82b.c
     core/planetsephems/elp82b.h
     core/planetsephems/gust86.c
     core/planetsephems/gust86.h
     core/planetsephems/l12.c
     core/planetsephems/l12.h
     core/planetsephems/marssat.c
     core/planetsephems/marssat.h
     core/planetsephems/pluto.c
     core/planetsephems/pluto.h
     core/planetsephems/precession.c
     core/planetsephems/precession.h
     core/planetsephems/sidereal_time.c
     core/planetsephems/sidereal_time.h
     core/planetsephems/jpl_int.h
     core/planetsephems/jpleph.h
     core/planetsephems/jpleph.cpp
     core/planetsephems/EphemWrapper.cpp
     core/planetsephems/EphemWrapper.hpp
     core/planetsephems/tass17.c
     core/planetsephems/tass17.h
     core/planetsephems/vsop87.c
     core/planetsephems/vsop87.h
     core/planetsephems/de430.cpp
     core/planetsephems/de430.hpp
     core/planetsephems/de431.cpp
     core/planetsephems/de431.hpp
     core/planetsephems/de440.cpp
     core/planetsephems/de440.hpp
     core/planetsephems/de441.cpp
     core/planetsephems/de441.hpp
     core/planetsephems/htc20b.c
     core/planetsephems/htc20b.h
     core/modules/AtmospherePreetham.cpp
     core/modules/AtmospherePreetham.hpp
     core/modules/AtmosphereShowMySky.cpp
     core/modules/AtmosphereShowMySky.hpp
     core/modules/Atmosphere.hpp
     core/modules/Asterism.cpp
     core/modules/Asterism.hpp
     core/modules/AsterismMgr.cpp
     core/modules/AsterismMgr.hpp
     core/modules/Constellation.cpp
     core/modules/Constellation.hpp
     core/modules/ConstellationMgr.cpp
     core/modules/ConstellationMgr.hpp
     core/modules/CoordObject.cpp
     core/modules/CoordObject.hpp
     core/modules/CustomObject.cpp
     core/modules/CustomObject.hpp
     core/modules/CustomObjectMgr.cpp
     core/modules/CustomObjectMgr.hpp
     core/modules/HighlightMgr.cpp
     core/modules/HighlightMgr.hpp
     core/modules/GridLinesMgr.cpp
     core/modules/GridLinesMgr.hpp
     core/modules/HipsMgr.hpp
     core/modules/HipsMgr.cpp
     core/modules/LabelMgr.hpp
     core/modules/LabelMgr.cpp
     core/modules/MarkerMgr.hpp
     core/modules/MarkerMgr.cpp
     core/modules/Landscape.cpp
     core/modules/Landscape.hpp
     core/modules/LandscapeMgr.cpp
     core/modules/LandscapeMgr.hpp
     core/modules/Meteor.cpp
     core/modules/Meteor.hpp
     core/modules/SporadicMeteor.cpp
     core/modules/SporadicMeteor.hpp
     core/modules/SporadicMeteorMgr.cpp
     core/modules/SporadicMeteorMgr.hpp
     core/modules/MilkyWay.cpp
     core/modules/MilkyWay.hpp
     core/modules/Nebula.cpp
     core/modules/Nebula.hpp
     core/modules/NebulaList.hpp
     core/modules/NebulaMgr.cpp
     core/modules/NebulaMgr.hpp
     core/modules/Orbit.cpp
     core/modules/Orbit.hpp
     core/modules/Planet.cpp
     core/modules/Planet.hpp
     core/modules/RotationElements.cpp
     core/modules/RotationElements.hpp
     core/modules/MinorPlanet.cpp
     core/modules/MinorPlanet.hpp
     core/modules/Comet.cpp
     core/modules/Comet.hpp
     core/modules/Skybright.cpp
     core/modules/Skybright.hpp
     core/modules/Skylight.cpp
     core/modules/Skylight.hpp
     core/modules/SolarSystem.cpp
     core/modules/SolarSystem.hpp
     core/modules/NomenclatureItem.cpp
     core/modules/NomenclatureItem.hpp
     core/modules/NomenclatureMgr.cpp
     core/modules/NomenclatureMgr.hpp
     core/modules/Solve.hpp
     core/modules/Star.cpp
     core/modules/Star.hpp
     core/modules/StarMgr.cpp
     core/modules/StarMgr.hpp
     core/modules/StarWrapper.cpp
     core/modules/StarWrapper.hpp
     core/modules/ToastMgr.hpp
     core/modules/ToastMgr.cpp
     core/modules/ZoneArray.cpp
     core/modules/ZodiacalLight.hpp
     core/modules/ZodiacalLight.cpp
     core/modules/ZoneArray.hpp
     core/modules/ZoneData.hpp
     core/modules/SpecialMarkersMgr.cpp
     core/modules/SpecialMarkersMgr.hpp
     core/modules/SpecificTimeMgr.cpp
     core/modules/SpecificTimeMgr.hpp
     StelMainView.hpp
     StelMainView.cpp
     StelSplashScreen.hpp
     StelSplashScreen.cpp
     StelLogger.hpp
     StelLogger.cpp
     StelSystemInfo.hpp
     StelSystemInfo.cpp
     CLIProcessor.hpp
     CLIProcessor.cpp
     translations.h
     translations_regions.h
)

IF(ENABLE_PCH)
     SET(stellarium_lib_SRCS ${stellarium_lib_SRCS}
         stelMain_pch.hpp
     )
ENDIF(ENABLE_PCH)

IF(ENABLE_SCRIPTING)
     SET(stellarium_lib_SRCS ${stellarium_lib_SRCS}
          scripting/StelScriptOutput.hpp
          scripting/StelScriptOutput.cpp
          scripting/V3d.cpp
          scripting/V3d.hpp
          scripting/StelScriptMgr.cpp
          scripting/StelScriptMgr.hpp
          scripting/ScreenImageMgr.hpp
          scripting/ScreenImageMgr.cpp
          scripting/StelMainScriptAPI.cpp
          scripting/StelMainScriptAPI.hpp
          scripting/StelMainScriptAPIProxy.cpp
          scripting/StelMainScriptAPIProxy.hpp
     )
ENDIF()

SET(stellarium_exe_SRCS main.cpp)

################# compiles resources files ############
SET(stellarium_RES ${CMAKE_SOURCE_DIR}/data/mainRes.qrc)
IF(${QT_VERSION_MAJOR} EQUAL "5")
     QT5_ADD_RESOURCES(stellarium_RES_CXX ${stellarium_RES})
ELSE()
     QT_ADD_RESOURCES(stellarium_RES_CXX ${stellarium_RES})
ENDIF()
#############################################################################################
############################# Standard GUI plugin compilation ###############################
#############################################################################################
IF(STELLARIUM_GUI_MODE STREQUAL "Standard")
     SET(stellarium_gui_SRCS
          gui/StelGui.hpp
          gui/StelGui.cpp
          gui/SkyGui.hpp
          gui/SkyGui.cpp
          gui/StelStyle.hpp
          gui/StelGuiItems.hpp
          gui/StelGuiItems.cpp
          gui/HelpDialog.hpp
          gui/HelpDialog.cpp
          gui/ShortcutLineEdit.hpp
          gui/ShortcutLineEdit.cpp
          gui/ShortcutsDialog.hpp
          gui/ShortcutsDialog.cpp
          gui/Dialog.hpp
          gui/Dialog.cpp
          gui/MapWidget.hpp
          gui/MapWidget.cpp
          gui/AngleSpinBox.hpp
          gui/AngleSpinBox.cpp
          gui/LocationDialog.hpp
          gui/LocationDialog.cpp
          gui/DateTimeDialog.hpp
          gui/DateTimeDialog.cpp
          gui/ViewDialog.hpp
          gui/ViewDialog.cpp
          gui/LightPollutionWidget.hpp
          gui/LightPollutionWidget.cpp
          gui/LogarithmicSpinBox.hpp
          gui/LogarithmicSpinBox.cpp
          gui/SearchDialog.hpp
          gui/SearchDialog.cpp
          gui/ConfigurationDialog.hpp
          gui/ConfigurationDialog.cpp
          gui/AddRemoveLandscapesDialog.hpp
          gui/AddRemoveLandscapesDialog.cpp
          gui/AtmosphereDialog.hpp
          gui/AtmosphereDialog.cpp
          gui/ConfigureDSOColorsDialog.hpp
          gui/ConfigureDSOColorsDialog.cpp
          gui/ConfigureOrbitColorsDialog.hpp
          gui/ConfigureOrbitColorsDialog.cpp
          gui/GreatRedSpotDialog.hpp
          gui/GreatRedSpotDialog.cpp
          gui/CustomDeltaTEquationDialog.hpp
          gui/CustomDeltaTEquationDialog.cpp
          gui/ConfigureScreenshotsDialog.hpp
          gui/ConfigureScreenshotsDialog.cpp
          gui/AstroCalcDialog.hpp
          gui/AstroCalcDialog.cpp
          gui/AstroCalcChart.hpp
          gui/AstroCalcChart.cpp
          gui/AstroCalcExtraEphemerisDialog.hpp
          gui/AstroCalcExtraEphemerisDialog.cpp
          gui/AstroCalcCustomStepsDialog.hpp
          gui/AstroCalcCustomStepsDialog.cpp
          gui/AstroCalcAlmanacWidget.hpp
          gui/AstroCalcAlmanacWidget.cpp
          gui/ObsListDialog.hpp
          gui/ObsListDialog.cpp
          gui/StelDialog.hpp
          gui/StelDialog_p.hpp
          gui/StelDialog.cpp
          gui/StelDialogSeparate.hpp
          gui/StelDialogSeparate.cpp
          gui/TonemappingDialog.hpp

=== landscapes/garching/CMakeLists.txt ===

########### install files ###############

# install landscape.ini
INSTALL (FILES landscape.ini DESTINATION ${SDATALOC}/landscapes/garching )

# install textures and descriptions
INSTALL (DIRECTORY ./ DESTINATION ${SDATALOC}/landscapes/garching
	FILES_MATCHING PATTERN "*.png" 
	PATTERN "description.*.utf8" 
	PATTERN "CMakeFiles" EXCLUDE )

=== landscapes/grossmugl/CMakeLists.txt ===

########### install files ###############

# install landscape.ini
INSTALL (FILES landscape.ini DESTINATION ${SDATALOC}/landscapes/grossmugl )

# install textures and descriptions
INSTALL (DIRECTORY ./ DESTINATION ${SDATALOC}/landscapes/grossmugl
	FILES_MATCHING PATTERN "*.png" 
	PATTERN "description.*.utf8" 
	PATTERN "gazetteer.*.utf8" 
	PATTERN "CMakeFiles" EXCLUDE )

=== landscapes/hurricane/CMakeLists.txt ===

########### install files ###############

# install landscape.ini
INSTALL (FILES landscape.ini DESTINATION ${SDATALOC}/landscapes/hurricane )

# install textures and descriptions
INSTALL (DIRECTORY ./ DESTINATION ${SDATALOC}/landscapes/hurricane
	FILES_MATCHING PATTERN "*.png" 
	PATTERN "description.*.utf8" 
	PATTERN "CMakeFiles" EXCLUDE )

=== landscapes/moon/CMakeLists.txt ===

########### install files ###############

# install landscape.ini
INSTALL (FILES landscape.ini DESTINATION ${SDATALOC}/landscapes/moon )

# install textures and descriptions
INSTALL (DIRECTORY ./ DESTINATION ${SDATALOC}/landscapes/moon
	FILES_MATCHING PATTERN "*.png" 
	PATTERN "description.*.utf8" 
	PATTERN "CMakeFiles" EXCLUDE )

=== landscapes/trees/CMakeLists.txt ===

########### install files ###############

# install landscape.ini
INSTALL (FILES landscape.ini DESTINATION ${SDATALOC}/landscapes/trees )

# install textures and descriptions
INSTALL (DIRECTORY ./ DESTINATION ${SDATALOC}/landscapes/trees
	FILES_MATCHING PATTERN "*.png" 
	PATTERN "description.*.utf8" 
	PATTERN "CMakeFiles" EXCLUDE )

=== landscapes/zero/CMakeLists.txt ===

########### install files ###############

# install landscape.ini
INSTALL (FILES landscape.ini DESTINATION ${SDATALOC}/landscapes/zero )

# install textures and descriptions
INSTALL (DIRECTORY ./ DESTINATION ${SDATALOC}/landscapes/zero
	FILES_MATCHING PATTERN "*.txt" 
	PATTERN "description.*.utf8" 
	PATTERN "CMake*" EXCLUDE )

=== plugins/ArchaeoLines/CMakeLists.txt ===
# This is the cmake config file for the ArchaeoLines plugin
# Versions:
#0.1.3 adding azimuth lines
#0.1.4 adding geographic locations
#0.1.5 using the StelProperty system
#0.1.6 adding arbitrary declinations
#0.1.7 adding license info for GUI
#0.1.8 adding 2 more lines to plugin (selected object azimuth and selected object hour angle)
#0.1.9 Refactor color settings, use properties more sensible.
#0.1.10 Refactor GUI
#0.1.11 Fix crossquarter declination
# Further: Use program version number. (Static plugin, why bother?)
SET(ARCHAEOLINES_VERSION "${VERSION}")
ADD_DEFINITIONS(-DARCHAEOLINES_PLUGIN_VERSION="${ARCHAEOLINES_VERSION}")
ADD_DEFINITIONS(-DARCHAEOLINES_PLUGIN_LICENSE="GNU GPLv2 or later")

ADD_SUBDIRECTORY( src )

=== plugins/EquationOfTime/CMakeLists.txt ===
# This is the cmake config file for the Equation of Time plugin
# Further: Use program version number. (Static plugin, why bother?)
SET(EQUATIONOFTIME_VERSION "${VERSION}")

ADD_DEFINITIONS(-DEQUATIONOFTIME_PLUGIN_VERSION="${EQUATIONOFTIME_VERSION}")
ADD_DEFINITIONS(-DEQUATIONOFTIME_PLUGIN_LICENSE="GNU GPLv2 or later")

ADD_SUBDIRECTORY( src )

=== debian/changelog ===
stellarium (25.2-0.1~mx25+1) mx; urgency=medium

  * New upstream version 25.2
  * Add alternate BD "qt6-serialport-dev".

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 21 Sep 2025 16:08:10 -0700

stellarium (25.1-0.1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Use correct version 25.1

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 24 Apr 2025 13:33:02 -0700

stellarium (25.1.0-upstream1.2~ubuntu22.04.1) jammy; urgency=low

  * Auto build.

 -- Alexander Wolf <alex.v.wolf@gmail.com>  Sun, 23 Mar 2025 17:51:59 +0000

stellarium (25.1.0-1) unstable; urgency=medium

  * New upstream version 25.1.0

 -- Alexander V. Wolf <alex.v.wolf@gmail.com>  Sun, 23 Mar 2025 21:00:00 +0700

stellarium (23.1.0-2) unstable; urgency=medium

  * New upstream version 23.1.0

 -- Alexander V. Wolf <alex.v.wolf@gmail.com>  Mon, 27 Mar 2023 16:00:00 +0700

stellarium (0.22.2-2) unstable; urgency=medium

  * New upstream version 0.22.2

 -- Alexander V. Wolf <alex.v.wolf@gmail.com>  Sun, 12 Jul 2022 13:00:00 +0700

=== debian/control ===
Source: stellarium
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Alexander Wolf <alex.v.wolf@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 11),
               debhelper-compat (= 11),
               doxygen,
               libexiv2-dev,
               libgps-dev,
               libindi-dev (>= 1.8.2),
               libindi-plugins (>= 1.8.2),
               libmd4c-dev,
               libmd4c-html0-dev,
               libnlopt-cxx-dev,
               libnova-dev,
               libqt6charts6-dev (>= 6.2) | qt6-charts-dev (>= 6.3),
               libqt6opengl6-dev (>= 6.2) | qt6-base-dev (>= 6.8),
               libqt6positioning6 (>= 6.2),
               libqt6positioning6-plugins (>= 6.2),
               qt6-serialport-dev,
               libqt6svg6-dev (>= 6.2),
               libqt6webchannel6 (>= 6.2) [amd64 arm64],
               qt6-webchannel-dev [amd64  arm64],
               libqt6webengine6-data (>= 6.2) [amd64 arm64],
               libqt6webenginecore6 (>= 6.2) [amd64 arm64],
               libqt6webenginecore6-bin (>= 6.2) [amd64 arm64],
               libqt6webenginewidgets6 (>= 6.2) [amd64 arm64],
               linguist-qt6 (>= 6.2),
               mesa-common-dev,
               qt6-base-dev (>= 6.2),
               qt6-base-private-dev (>= 6.2),
               qt6-l10n-tools (>= 6.2),
               qt6-multimedia-dev (>= 6.2),
               qt6-positioning-dev (>= 6.2),
               qt6-tools-dev (>= 6.2),
               qt6-tools-dev-tools (>= 6.2),
               qt6-webengine-dev (>= 6.2) [amd64 arm64],
               qt6-webengine-dev-tools (>= 6.2) [amd64 arm64],
               zlib1g-dev
Standards-Version: 4.5.0
Vcs-Browser: https://github.com/Stellarium/stellarium
Vcs-Git: https://github.com/Stellarium/stellarium.git
Homepage: https://www.stellarium.org

Package: stellarium
Replaces: stellarium-qt6
Conflicts: stellarium-qt6
Architecture: any
Depends: libqt6webengine6-data (>= 6.2) [amd64 arm64],
         libqt6webenginecore6-bin (>= 6.2) [amd64 arm64],
         qt6-qpa-plugins (>= 6.2),
         qt6-wayland (>= 6.2),
         stellarium-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: real-time photo-realistic sky generator
 Stellarium renders 3D photo-realistic skies in real-time. With Stellarium, you
 really see what you can see with your eyes, binoculars or a small telescope.
 .
 Some features:
  - default star catalogue with over 600 thousand stars,
  - information about the brightest stars (spectral type, distance, etc.),
  - downloadable star catalogue extensions, for up to 210 million stars,
  - all New General Catalogue (NGC) objects,
  - images of almost all Messier objects and the Milky Way,
  - real time positions of the planets and their satellites,
  - 46 different cultures with their constellations,
  - artistic illustrations of the 88 Western constellations,
  - very realistic atmosphere, sunrise and sunset,
  - 7 panoramic landscapes (more can be made or downloaded from the website),
  - scripting with ECMAScript,
  - plug-in support: Stellarium comes with 22 plug-ins by default, including:
  - artificial satellites plug-in (updated from an on-line TLE database),
  - ocular simulation plug-in (shows how objects look like in a given ocular),
  - Solar System editor plug-in (imports comet and asteroid data from the MPC),
  - telescope control plug-in (Meade LX200 and Celestron NexStar compatible).
 .
 Stellarium should not be used for very high accurate calculation or ephemerids
 like eclipse predictions. However, it is the ideal program to prepare an
 observation evening with naked eye, binocular, or small telescope.

Package: stellarium-data
Replaces: stellarium-qt6-data
Architecture: all
Depends: fonts-dejavu-core, ${misc:Depends}
Recommends: stellarium (= ${source:Version})
Description: Stellarium data files
 Stellarium renders 3D photo-realistic skies in real-time. With Stellarium, you
 really see what you can see with your eyes, binoculars or a small telescope.
 .
 This package contains data files required by Stellarium. They include
 textures, star catalogues and translations.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_install:
	dh_install
	rm debian/tmp/usr/share/stellarium/data/DejaVuSans.ttf
	rm debian/tmp/usr/share/stellarium/data/DejaVuSansMono.ttf

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Release \
	                     -DENABLE_SHOWMYSKY=OFF \
	                     -DENABLE_XLSX=OFF \
	                     -DENABLE_INDI=ON

# No dbgsym packages:
override_dh_strip:
	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym
